unit Unit2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, IdIOHandler,
  IdIOHandlerSocket, IdIOHandlerStack, IdSSL, IdSSLOpenSSL, Soap.InvokeRegistry,
  Soap.Rio, Soap.SOAPHTTPClient, Soap.SOAPHTTPTrans,
  Winapi.WinInet;

type
  TForm2 = class(TForm)
    IdHTTP1: TIdHTTP;
    Button1: TButton;
    Memo1: TMemo;
    IdSSLIOHandlerSocketOpenSSL1: TIdSSLIOHandlerSocketOpenSSL;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

const
  url: string = 'https://www.facebook.com/devgear';

procedure TForm2.Button1Click(Sender: TObject);
var
  data: string;
begin
  IdHTTP1.IOHandler := IdSSLIOHandlerSocketOpenSSL1;
  IdHTTP1.HandleRedirects := True;
  try
    data := IdHTTP1.Get(url);
  except
  end;

  Memo1.Lines.Text := data;
end;

procedure CrackURL(const URL: String; out Scheme: Word; out UserName, Password, Host: String; out Port: Word; out ObjName: String);
var
  Parts: TURLComponents;
  CanonicalURL: String;
  Size: Cardinal;
begin
  FillChar(Parts, SizeOf(TURLComponents), 0);
  Parts.dwStructSize := SizeOf(TURLComponents);
  if URL <> '' then
  begin
    Size := 3 * Length(URL);
    SetString(CanonicalURL, nil, Size);
    if not InternetCanonicalizeUrl(PChar(URL), PChar(CanonicalURL), Size, ICU_NO_META) then
      Size := 0;
    SetLength(CanonicalURL, Size);
    Parts.dwSchemeLength := 1;
    Parts.dwUserNameLength := 1;
    Parts.dwPasswordLength := 1;
    Parts.dwHostNameLength := 1;
    Parts.dwURLPathLength := 1;
    Parts.dwExtraInfoLength := 1;
    InternetCrackUrl(PChar(CanonicalURL), Size, 0, Parts);
  end;
  Scheme := Parts.nScheme;
  SetString(UserName, Parts.lpszUserName, Parts.dwUserNameLength);
  SetString(Password, Parts.lpszPassword, Parts.dwPasswordLength);
  SetString(Host, Parts.lpszHostName, Parts.dwHostNameLength);
  Port := Parts.nPort;
  SetString(ObjName, Parts.lpszUrlPath, Parts.dwUrlPathLength + Parts.dwExtraInfoLength);
end;

function GetUrlContent(const URL: String): String;
const
  AcceptType: array[0..1] of PChar = ('*/*', nil);
var
  hINet, hConn, hReq: HINTERNET;
  UserName, Password, Host, ObjName: String;
  Scheme, Port: Word;
  dwSize, dwError: DWORD;
  ReqFlags, Size: Cardinal;
  Stream: TStringStream;
  Buffer: array[0..255] of Byte;
begin
  Result := '';
  hINet := InternetOpen('Mozila/5.0', INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, 0);
  if hINet <> nil then begin
    try
      CrackURL(URL, Scheme, UserName, Password, Host, Port, ObjName);
      hConn := InternetConnect(hINet, PChar(Host), Port, PChar(UserName), PChar(Password), INTERNET_SERVICE_HTTP, 0, 0);
      if hConn <> nil then begin
        try
          ReqFlags := INTERNET_FLAG_RELOAD or INTERNET_FLAG_PRAGMA_NOCACHE
                   or INTERNET_FLAG_NO_CACHE_WRITE or INTERNET_FLAG_NO_COOKIES
                   or INTERNET_FLAG_NO_UI or INTERNET_FLAG_KEEP_CONNECTION;
          if Scheme = INTERNET_SCHEME_HTTPS then begin
            ReqFlags := ReqFlags or INTERNET_FLAG_SECURE;
          end;
          hReq := HttpOpenRequest(hConn, 'GET', PChar(ObjName), nil, nil, @AcceptType[0], ReqFlags, 0);
          if hReq <> nil then begin
            dwSize:=SizeOf(ReqFlags);
            // Get the current flags
            if Scheme = INTERNET_SCHEME_HTTPS then begin
              if (InternetQueryOption(hReq, INTERNET_OPTION_SECURITY_FLAGS, @ReqFlags, dwSize)) then begin
                 // Add desired flags
                 ReqFlags := ReqFlags
                              or SECURITY_FLAG_IGNORE_UNKNOWN_CA
                              or SECURITY_FLAG_IGNORE_CERT_CN_INVALID
                              or SECURITY_FLAG_IGNORE_CERT_DATE_INVALID
                              or SECURITY_FLAG_IGNORE_REVOCATION;
                 // Set new flags
                 if not(InternetSetOption(hReq, INTERNET_OPTION_SECURITY_FLAGS, @ReqFlags, dwSize)) then begin
                    // Get error code
                    dwError := GetLastError;
                    // Failure
                    MessageBox(0, PChar(IntToStr(dwError)), PChar('Confirm'), MB_OK or MB_ICONINFORMATION);
                 end;
              end else begin
                 // Get error code
                 dwError := GetLastError;
                 // Failure
                 MessageBox(0, PChar(IntToStr(dwError)), PChar('Confirm'), MB_OK or MB_ICONINFORMATION);
              end;
            end;

            try
              if HttpSendRequest(hReq, nil, 0, nil, 0) then begin
                Stream := TStringStream.Create('');
                try
                  while InternetReadFile(hReq, @Buffer[0], SizeOf(Buffer), Size) and (Size <> 0) do begin
                    Stream.Write(Buffer[0], Size);
                  end;
                  Result := Stream.DataString;
                finally
                  Stream.Free;
                end;
              end;
            finally
              dwError := GetLastError;
//              MessageBox(0, PChar(IntToStr(dwError)), PChar('Confirm'), MB_OK or MB_ICONINFORMATION);
              InternetCloseHandle(hReq);
            end;
          end;
        finally
          InternetCloseHandle(hConn);
        end;
      end;
    finally
      InternetCloseHandle(hINet);
    end;
  end;
end;

procedure TForm2.Button2Click(Sender: TObject);
var
  data: string;
begin
  data := GetUrlContent(url);

  Memo1.Lines.Text := data;
end;

end.
